package cleii.data;

/*
 * Definisco le classi relative agli elementi contenuti nella tabella con hashing interno
 */

abstract class IHTElem<T>{
	
}

class EmptyIHTElem<T> extends IHTElem<T> {
	
}

class DeletedIHTElem<T> extends IHTElem<T> {
	
}

class ValuedIHTElem<T> extends IHTElem<T> {
	private T value;
	
	public ValuedIHTElem(T x) {
		value=x;
	}
	
	public T getValue() {
		return value;
	}
}




public abstract class InternalHashTable<T> extends HashTable<T> {
	protected IHTElem<T>[] a;

	public InternalHashTable (int k, double maxLoad) {
		super (k, maxLoad);
		a = new IHTElem[this.k];
		for (int i=0; i<this.k; i++) {
			a[i]= new EmptyIHTElem<T>();
		}
	}
	
	abstract protected int h (T x, int i);
	
	
	@Override
	public void insert(T x) {
		// controllo che x non sia gi presente
		if (search(x)!=null) {
			return;
		}
		boolean inserito=false;
		int i=0;
		do {
			int pos = h(x,i);
			if (a[pos] instanceof EmptyIHTElem || a[pos] instanceof DeletedIHTElem) {
				a[pos] = new ValuedIHTElem<T>(x);
				inserito=true;
			}
			i++;
		} while (i<this.k && !inserito);
		if (inserito) {
			size++;
			//eventuale ridimensionamento... lo faremo successivamente (ESERCIZIO)
		} else {
			System.out.println ("ERRORE: tabella piena");
		}
	}

	@Override
	public T search(T x) {
		for (int i=0; i<this.k; i++) {
			int pos = h(x,i);
			if (a[pos] instanceof EmptyIHTElem) return null;
			if (a[pos] instanceof ValuedIHTElem && 
					x.equals( ((ValuedIHTElem<T>)a[pos]).getValue() ) )
				return ((ValuedIHTElem<T>)a[pos]).getValue();
		}
		return null;
	}

	@Override
	public void delete(T x) {
		for (int i=0; i<this.k; i++) {
			int pos = h(x,i);
			if (a[pos] instanceof EmptyIHTElem) return;
			if (a[pos] instanceof ValuedIHTElem && 
					x.equals( ((ValuedIHTElem<T>)a[pos]).getValue() ) ) {
				size--;
				a[pos] = new DeletedIHTElem<T>();
				return;
			}
		}
	}

}
