package cleii.data;

/*
 * classe che implementa l'hashing esterno
 */

public class ListHashTable<T> extends HashTable<T> {
	private List<T>[] a;
	
	public ListHashTable (int k, double maxLoad) {
		super (k, maxLoad);
		a = new List[this.k]; //Questa riga la chiariremo verso la fine del corso
		for (int i=0; i<this.k; i++) {
			a[i]= new List<T>();
		}
	}
	
	private int h(T x) {
		int code = x.hashCode();
		if (code<0) code = -code;
		return code % this.k; 
	}
	
	@Override
	public void insert(T x) {
		a[h(x)].insert(x);
		size++;
		if ( ((double)size) / this.k > getMaxLoad() ) {
			redim(this.k*2);
		}
	}

	@Override
	public T search(T x) {
		return a[h(x)].search(x);
	}

	@Override
	public void delete(T x) {
		if (a[h(x)].delete(x)) {
			size--;
		}
	}
	
	private void redim (int newK) {
		ListHashTable<T> newHT= new ListHashTable<>(newK, getMaxLoad());
		// bisogna riversare tutti gli elementi della tabella hash corrente nella nuova
		for (int i=0; i<a.length; i++) {
			List<T> l = a[i];
			/*
			Elem<T> e = l.getFirst();
			while (e!=null) {
				newHT.insert(e.getValue());
				e = e.getNext();
			}
			*/
			for (Elem<T> e = l.getFirst(); e!=null; e=e.getNext()) {
				newHT.insert(e.getValue());
			}
		}
		this.a=newHT.a; //sostituisco l'array corrente con quello della nuova tabella hash
		this.k=newHT.k;
	}

}
